#ifdef _Windows
#include <windows.h>
#elif defined(linux) /* ou autres Unix qui possdent NCurses */
#include <ncurses.h>
#define UTILISE_NCURSES
#elif defined(__MSDOS__)
#include <dos.h>
#endif

#include<stdio.h>
#include<string.h>

#define factFile "facture.txt"
#define frsFile "fournisseur.txt"
#define pdtFile "produit.txt"
#define lvrFile "livraison.txt"
#define cdeFile "commande.txt"

struct colsFacture
    {
    int numero_fact;
    char date_fact[10];
	int code_pdt_fact;
    int qte_vendue_fact;
    struct colsFacture *suivant;     
    };

struct colsProduit
    {
    int code_pdt;
    char nom_pdt[20];
    int prix_unitaire_pdt;
    int stock_min_pdt;
    int qte_en_stock_pdt;
    int qte_cde_auto_pdt;
    struct colsProduit *suivant;     
    };
    
struct colsCommande
    {
    int numero_cde;
    int code_pdt_cde;
    int code_frs_cde;
    char date_cde[10];
    int qte_cde;
    struct colsCommande *suivant;     
    };
    
struct colsLigneFacture
    {
    char nom_pdt_fact[20];  
    int qte_fact; 
    int pu_fact;
    struct colsLigneFacture *suivant;  
    };

struct colsFournisseur
    {
    int code_frs;
    char nom_frs[20];
    char ville_frs[15];
    struct colsFournisseur *suivant;     
    };

struct colsLivraison
    {
    int numero_lvr;
    int code_pdt_lvr;
    int code_frs_lvr;
    char date_lvr[10];
    int qte_lvr;
    struct colsLivraison *suivant;     
    };

struct colsFacture *debutListFacture = NULL;
struct colsProduit *debutListProduit = NULL;
struct colsCommande *debutListCommande = NULL;
struct colsLivraison *debutListLivraison = NULL;
struct colsFournisseur *debutListFournisseur = NULL;
struct colsLigneFacture *debutListLigneFacture = NULL;

int lastValueNumeroFacture = 0;
int lastValueCodeProduit = 0;
int lastValueCodeLivraison=0;
int lastValueCodeCommande=0;
int lastValueCodeFournisseur=0;

int nbMaxFacture = 0;
int nbMaxProduit = 0;
int nbCommande = 0;
int nbFournisseur = 0;
int nbMaxCommande = 0;
int nbMaxFournisseur = 0;
int nbMaxLivraison=0;

char nomProduitFacture[20];
int prixUnitaireFacture = 0;
int qteEnStockProduit = 0;

void addFacture();
void addFournisseur();
void addProduit();
void addCommande();
void addLivraison();
void addCommandeAuto(int qte_auto,int code_pdt);
void addLigneFacture(int qte_vendue);

void openFournisseur();
void openProduit();
void openCommande();
void openLivraison();
void openFacture();

void searchFournisseur();
void searchProduit();
void searchCommande();
void searchLivraison();
void searchFacture();
int searchProduitFacture(int codeRecherche);

int fournisseurExist(int numero_frs);

void deleteFournisseur();
void deleteProduit();
void deleteCommande();
void deleteLivraison();
void deleteFacture();

void displayFournisseur();
void displayProduit();
void displayCommande();
void displayLivraison();
void displayFacture();
void displayDetailFacture();

void updateFournisseur();
void updateProduit();
void updateCommande();
void updateLivraison();
void updateQteEnStockFacture(int qte_vendue,int code_pdt_fact);
void updateQteEnStockLivraison(int qte_lvr,int code_pdt_lvr);

void displayMenuPrincipal();
void displayMenuCaisse();
void displayMenuGestionStock();

void displayMenuProduits();
void displayMenuFournisseurs();
void displayMenuCommandes();
void displayMenuLivraisons();

void clearScreen();

main()
    {
    // Affichage du menu principal
    displayMenuPrincipal();
    }

/*/ Nettoyage de l'cran
void clearScreen()
    {
    system("cls");
    }
*/
/* Efface l'cran texte et se positionne le curseur en haut  gauche */
void clearScreen(void)
{
   #if defined(UTILISE_NCURSES)
   clear();
   move (0,0);
   #elif defined(_Windows)

   /* Dbut : (1,1) */
   CONSOLE_SCREEN_BUFFER_INFO Info;
   COORD Debut;
   DWORD NbrOctetEcrit;
   Debut.X = 0;
   Debut.Y = 0;

   /* Lit les infos sur le buffer */
   GetConsoleScreenBufferInfo (HdlConsole, &Info);

   /* Remplit l'cran avec le caractre espace : ' ' */
   FillConsoleOutputCharacter (HdlConsole, ' ', Info.dwSize.X*Info.dwSize.Y, Debut, &NbrOctetEcrit);

   /* Positionne le curseur */
   SetConsoleCursorPosition (HdlConsole,Debut);
   #elif defined(__MSDOS__)
   union REGS inregs, outregs;
   struct SREGS segregs;
   inregs.h.ah = 0x00;   /* Fonction 00h : Change de mode video */
   inregs.h.ah = 0x03;   /* Mode = 03h : 80x25 caracteres, 16 couleurs */
   int86x(0x10, &inregs, &outregs, &segregs); /* Interruption 10h : Video */
   #endif
}



void displayMenuPrincipal()
    {
    int nbCaractere = 0;
    char choix = 'A', chaine_choix[20], login[15], password[10], c;
    while ( choix != 'Q' )
        {
        c = 'A';
        printf("\n\n ********************************* \n");
        printf(" *     Bienvenue a GECAISTO      * \n");
        printf(" *     Application de gestion    * \n");
        printf(" *     de Caisse et de Stock     * \n");
        printf(" *     d'un supermarche          * \n");
        printf(" ********************************* \n\n\n");
        printf(" Menu principale \n");
        printf(" --------------- \n");
        printf(" 1. Gestion de stock \n");
        printf(" 2. Caisse \n");
        printf(" Q. Quitter\n\n");
        printf("Entrez votre choix : ");
        scanf("%s", chaine_choix);
        choix = chaine_choix[0];
        switch ( choix )
            {
            case '1' : 
                displayMenuGestionStock();
                break ;
            case '2' : 
                displayMenuCaisse();
                break ;
            case 'Q' : 
                printf("\n\nAu revoir ");
                break ;
            default: 
                clearScreen();
                printf("Choix invalide! Recommencer\n\n");
                break;
            }
        }
    }

// Menu Caisse
void displayMenuCaisse()
    {
    char choix = 'A', chaine_choix[20];
    clearScreen();
    openProduit();
    openFacture();
    while ( choix != 'R' )
        {
        printf("\n\nMenu Caisse\n");
        printf("--------------\n\n");
        printf("1. Etablir une facture\n");
        printf("2. Supprimer une facture\n");
        printf("3. Rechercher une facture\n");
        printf("4. Consultation produits\n");
        printf("R. Revenir au menu principal\n\n");
        printf("Entrez votre choix : ");
        scanf("%s", chaine_choix);
        choix = chaine_choix[0];
        switch( choix )
            {
            case '1':
                clearScreen();
                addFacture();
                break;
            case '2':
                clearScreen();
                deleteFacture();
                break;
            case '3':
                clearScreen();
                searchFacture();
                break;
            case '4':
                clearScreen();
                displayProduit();
                break;
            case 'R':
                clearScreen();
                break;
            default:
                clearScreen();
                printf("Choix invalide! Recommencer\n\n");
                break;
            break;
            }
        }
    
    }

// Menu gestion de Stock
void displayMenuGestionStock()
    {
    char choix = 'A', chaine_choix[20];
    clearScreen();
    while ( choix != 'R' )
        {
        printf("\n\nMenu Gestion de Stock\n");
        printf("---------------------\n\n");
        printf("1. Fournisseurs\n");
        printf("2. Produits\n");
        printf("3. Commandes\n");
        printf("4. Livraisons\n");
        printf("R. Revenir au menu principal\n\n");
        printf("Entrez votre choix : ");
        scanf("%s", chaine_choix);
        choix = chaine_choix[0];
        switch( choix )
            {
            case '1':
                clearScreen();
                displayMenuFournisseurs();
                break;
            case '2':
                clearScreen();
                displayMenuProduits();
                break;
            case '3':
                clearScreen();
                displayMenuCommandes();
                break;
            case '4':
                clearScreen();
                displayMenuLivraisons();
                break;
            case 'R':
                clearScreen();
                break;
            default:
                clearScreen();
                printf("Choix invalide! Recommencer\n\n");
                break;
            break;
            }
        }
    } 

// Menu fournisseurs
void displayMenuFournisseurs()
    {
    char choix = 'A', chaine_choix[20];
    clearScreen();
    openFournisseur();
    while ( choix != 'R' )
        {
        printf("\n\nMenu Fournisseurs\n");
        printf("-----------------\n\n");
        printf("1. Ajouter un fournisseur\n");
        printf("2. Modifier un fournisseur\n");
        printf("3. Supprimer un fournisseur\n");
        printf("4. Rechercher un fournisseur\n");
        printf("5. Consulter un fournisseur\n");
        printf("R. Revenir au menu gestion de stock\n\n");
        printf("Entrez votre choix : ");
        scanf("%s", chaine_choix);
        choix = chaine_choix[0];
        switch( choix )
            {
            case '1':
                clearScreen();
                addFournisseur();
                break;
            case '2':
                clearScreen();
                updateFournisseur();
                break;
            case '3':
                clearScreen();
                deleteFournisseur();
                break;
            case '4':
                clearScreen();
                searchFournisseur();
                break;
            case '5':
                clearScreen();
                displayFournisseur();
                break;
            case 'R':
                clearScreen();
                break;
            default:
                clearScreen();
                printf("Choix invalide! Recommencer\n\n");
                break;
            break;
            }
        }
    }

// Menu produits
void displayMenuProduits()
    {
    char choix = 'A', chaine_choix[20];
    clearScreen();
    openProduit();
    while ( choix != 'R' )
        {
        printf("\n\nMenu Produits\n");
        printf("-----------------\n\n");
        printf("1. Ajouter un produit\n");
        printf("2. Modifier un produit\n");
        printf("3. Supprimer un produit\n");
        printf("4. Rechercher un produit\n");
        printf("5. Consulter un produit\n");
        printf("R. Revenir au menu gestion de stock\n\n");
        printf("Entrez votre choix : ");
        scanf("%s", chaine_choix);
        choix = chaine_choix[0];
        switch( choix )
            {
            case '1':
                clearScreen();
                addProduit();
                break;
            case '2':
                clearScreen();
                updateProduit();
                break;
            case '3':
                clearScreen();
                deleteProduit();
                break;
            case '4':
                clearScreen();
                searchProduit();
                break;
            case '5':
                clearScreen();
                displayProduit();
                break;
            case 'R':
                clearScreen();
                break;
            default:
                clearScreen();
                printf("Choix invalide! Recommencer\n\n");
                break;
            break;
            }
        }
    }

// Menu commandes
void displayMenuCommandes()
    {
    char choix = 'A', chaine_choix[20];
    clearScreen();
    openCommande();
    while ( choix != 'R' )
        {
        printf("\n\nMenu Commandes\n");
        printf("-----------------\n\n");
        printf("1. Ajouter une commande\n");
        printf("2. Modifier une commande\n");
        printf("3. Supprimer une commande\n");
        printf("4. Rechercher une commande\n");
        printf("5. Consulter une commande\n");
        printf("R. Revenir au menu gestion de stock\n\n");
        printf("Entrez votre choix : ");
        scanf("%s", chaine_choix);
        choix = chaine_choix[0];
        switch( choix )
            {
            case '1':
                clearScreen();
                addCommande();
                break;
            case '2':
                clearScreen();
                updateCommande();
                break;
            case '3':
                clearScreen();
                deleteCommande();
                break;
            case '4':
                clearScreen();
                searchCommande();
                break;
            case '5':
                clearScreen();
                displayCommande();
                break;
            case 'R':
                clearScreen();
                break;
            default:
                clearScreen();
                printf("Choix invalide! Recommencer\n\n");
                break;
            break;
            }
        }
    }

// Menu livraisons
void displayMenuLivraisons()
    {
    char choix = 'A', chaine_choix[20];
    clearScreen();
    openLivraison();
    while ( choix != 'R' )
        {
        printf("\n\nMenu Livraisons\n");
        printf("-----------------\n\n");
        printf("1. Ajouter une livraison\n");
        printf("2. Modifier une livraison\n");
        printf("3. Supprimer une livraison\n");
        printf("4. Rechercher une livraison\n");
        printf("5. Consulter une livraison\n");
        printf("R. Revenir au menu gestion de stock\n\n");
        printf("Entrez votre choix : ");
        scanf("%s", chaine_choix);
        choix = chaine_choix[0];
        switch( choix )
            {
            case '1':
                clearScreen();
                openProduit();
                addLivraison();
                break;
            case '2':
                clearScreen();
                updateLivraison();
                break;
            case '3':
                clearScreen();
                deleteLivraison();
                break;
            case '4':
                clearScreen();
                searchLivraison();
                break;
            case '5':
                clearScreen();
                displayLivraison();
                break;
            case 'R':
                clearScreen();
                break;
            default:
                clearScreen();
                printf("Choix invalide! Recommencer\n\n");
                break;
            break;
            }
        }
    
    }

    
void displayLivraison()
    {
    int i = 0;
    struct colsLivraison *livraison = NULL;
    if(debutListLivraison!=NULL)
        {
        livraison = debutListLivraison;
        printf("\n\nConsultation livraison\n");
        printf("------------------------\n\n");
        printf("NumLvr CodeFrs CodePdt DateLvr    qte_lvr\n");
        printf("----------------------------------------\n");
        while(i < nbMaxLivraison)
            {
            printf("L%-5d F%-6d P%-6d %-10s %-6d\n", (*livraison).numero_lvr,(*livraison).code_frs_lvr,(*livraison).code_pdt_lvr,
            (*livraison).date_lvr,(*livraison).qte_lvr);
            livraison=(*livraison).suivant; 
            i++;
            }
        printf("\n");
        printf("Nombre de livraisons lues : %d\n\n", nbMaxLivraison);  
        }
    else
        {
        printf("Informations sur les livraisons inexistantes\n\n");
        }
    }

    
struct colsFacture *tallocFacture()
    {
    return (struct colsFacture *)malloc(sizeof(struct colsFacture));   
    }

struct colsLigneFacture *tallocLigneFacture()
    {
    return (struct colsLigneFacture *)malloc(sizeof(struct colsLigneFacture));   
    }

struct colsProduit *tallocProduit()
    {
    return (struct colsProduit *)malloc(sizeof(struct colsProduit));   
    }

struct colsCommande *tallocCommande()
    {
    return (struct colsCommande *)malloc(sizeof(struct colsCommande));   
    }

struct colsFournisseur *tallocFournisseur()
    {
    return (struct colsFournisseur *)malloc(sizeof(struct colsFournisseur));   
    }
    
struct colsLivraison *tallocLivraison()
    {
    return (struct colsLivraison *)malloc(sizeof(struct colsLivraison));   
    }

    
void openFournisseur()
    {
    struct colsFournisseur *tmpFournisseur = NULL, *fournisseur = NULL;
    FILE *entree;
    int ligne, i = 0;
    entree = fopen (frsFile, "r");
    if(entree != NULL)
        {
        if(debutListFournisseur!=NULL)
        {
          nbMaxFournisseur=0;
          lastValueCodeFournisseur=0;
          tmpFournisseur=debutListFournisseur;
          while((*tmpFournisseur).suivant!=NULL)
          {
           debutListFournisseur=(*debutListFournisseur).suivant;
           free(tmpFournisseur);
           tmpFournisseur = debutListFournisseur;
          }
          if((*tmpFournisseur).suivant==NULL && tmpFournisseur!=NULL)
           {
             free(tmpFournisseur);
             debutListFournisseur=NULL;  
           }
        }
        if(!feof(entree))
            {
            lastValueCodeFournisseur=0;
            }
        while(!feof(entree))
            {
            fournisseur = tallocFournisseur();
            (*fournisseur).suivant = NULL;
            ligne = fscanf(entree,"%d %s %s", &(*fournisseur).code_frs, (*fournisseur).nom_frs, (*fournisseur).ville_frs);
            if(ligne != EOF)
                {
                i++;
                if(debutListFournisseur == NULL)
                    {
                    debutListFournisseur = fournisseur;
                    tmpFournisseur = debutListFournisseur;
                    (*tmpFournisseur).suivant = NULL;
                    lastValueCodeFournisseur = (*fournisseur).code_frs;
                    fournisseur = NULL;
                    }
                else
                    {
                    (*tmpFournisseur).suivant = fournisseur;
                    tmpFournisseur = fournisseur;
                    (*tmpFournisseur).suivant = NULL;
                    lastValueCodeFournisseur = (*fournisseur).code_frs;
                    fournisseur = NULL; 
                    }
                }
            }
        }
    fclose(entree);
    nbMaxFournisseur = i;
    }



void openFacture()
    {
    struct colsFacture *tmpFacture = NULL, *facture = NULL;
    FILE *entree;
    int ligne, i = 0;
    entree = fopen (factFile, "r");
    if(entree != NULL)
        {
        if(debutListFacture != NULL)
        {
          nbMaxFacture = 0;
          lastValueNumeroFacture = 0;
          tmpFacture = debutListFacture;
          while((*tmpFacture).suivant != NULL)
          {
           debutListFacture = (*debutListFacture).suivant;
           free(debutListFacture);
           tmpFacture = debutListFacture;
          }
          if((*tmpFacture).suivant == NULL && tmpFacture!=NULL)
          {
            free(debutListFacture);
            debutListFacture=NULL;
          }
        }
        if(!feof(entree))
            {
            lastValueNumeroFacture=0;
            }
        while(!feof(entree))
            {
            facture = tallocFacture();
            (*facture).suivant=NULL;
            int numero_fact;
            ligne = fscanf(entree,"%d %s %d %d\n", &(*facture).numero_fact ,(*facture).date_fact, &(*facture).code_pdt_fact,
            &(*facture).qte_vendue_fact);
            if(ligne != EOF)
                {
                i++;
                if(debutListFacture == NULL)
                    {
                    debutListFacture = facture;
                    tmpFacture = debutListFacture;
                    (*tmpFacture).suivant = NULL;
                    lastValueNumeroFacture = (*facture).numero_fact;
                    facture = NULL;
                    }
                else
                    {
                    (*tmpFacture).suivant = facture;
                    tmpFacture = facture;
                    lastValueNumeroFacture = (*facture).numero_fact;
                    facture = NULL; 
                    }
                }
            }
        }
    fclose(entree);
    nbMaxFacture = i;
    }

void openProduit()
    {
    struct colsProduit *tmpProduit = NULL, *produit = NULL;
    FILE *entree;
    int ligne, i = 0;
    entree = fopen (pdtFile, "r");
    if(entree != NULL)
        {
        if(debutListProduit!=NULL)
        {
          nbMaxProduit=0;
          lastValueCodeProduit=0;
          tmpProduit=debutListProduit;
          while((*tmpProduit).suivant!=NULL)
          {
           debutListProduit=(*debutListProduit).suivant;
           free(debutListProduit);
           tmpProduit = debutListProduit;
          }
          if((*tmpProduit).suivant ==NULL && tmpProduit!=NULL )
          {
            free(tmpProduit);
            debutListProduit=NULL;
          }
        }
        if(!feof(entree))
            {
            lastValueCodeProduit=0;
            }
        while(!feof(entree))
            {
            produit = tallocProduit();
            (*produit).suivant = NULL;
            int code_pdt;
            ligne = fscanf(entree,"%d %s %d %d %d %d", &(*produit).code_pdt, (*produit).nom_pdt, &(*produit).prix_unitaire_pdt, 
            &(*produit).stock_min_pdt, &(*produit).qte_en_stock_pdt, &(*produit).qte_cde_auto_pdt);
            if(ligne != EOF)
                {
                i++;
                if(debutListProduit == NULL)
                    {
                    debutListProduit = produit;
                    tmpProduit = debutListProduit;
                    (*tmpProduit).suivant = NULL;
                    lastValueCodeProduit = (*produit).code_pdt;
                    produit = NULL;
                    }
                else
                    {
                    (*tmpProduit).suivant = produit;
                    tmpProduit = produit;
                    (*tmpProduit).suivant = NULL;
                    lastValueCodeProduit = (*produit).code_pdt;
                    produit = NULL; 
                    }
                }
            }
        }
    fclose(entree);
    nbMaxProduit = i;
    }
    
    
void openCommande()
    {
    struct colsCommande *tmpCommande = NULL, *commande = NULL;
    FILE *entree;
    int ligne, i = 0;
    entree = fopen (cdeFile, "r");
    if(entree != NULL)
        {
        if(debutListCommande != NULL)
        {
          nbMaxCommande = 0;
          lastValueCodeCommande = 0;
          tmpCommande = debutListCommande;
          while((*tmpCommande).suivant != NULL)
          {
           debutListCommande = (*debutListCommande).suivant;
           free(tmpCommande);
           tmpCommande = debutListCommande;
          }
           if((*tmpCommande).suivant == NULL && tmpCommande!=NULL)
           {
             free(tmpCommande);
             debutListCommande=NULL;
           }
        }
        if(!feof(entree))
            {
            lastValueCodeCommande=0;
            }
        while(!feof(entree))
            {
            commande = tallocCommande();
            (*commande).suivant = NULL;
            int numero_cde;
            ligne = fscanf(entree,"%d %d %d %s %d\n", &(*commande).numero_cde ,&(*commande).code_frs_cde, &(*commande).code_pdt_cde,
            (*commande).date_cde, &(*commande).qte_cde);
            if(ligne != EOF)
                {
                i++;
                if(debutListCommande == NULL)
                    {
                    debutListCommande = commande;
                    tmpCommande = debutListCommande;
                    (*tmpCommande).suivant = NULL;
                    lastValueCodeCommande = (*commande).numero_cde;
                    commande = NULL;
                    }
                else
                    {
                    (*tmpCommande).suivant = commande;
                    tmpCommande = commande;
                    (*tmpCommande).suivant = NULL;
                    lastValueCodeCommande = (*commande).numero_cde;
                    commande = NULL; 
                    }
                }
            }
        }
    fclose(entree);
    nbMaxCommande = i;
    }

void openLivraison()
    {
    struct colsLivraison *tmpLivraison = NULL, *livraison = NULL;
    FILE *entree;
    int ligne, i = 0;
    entree = fopen (lvrFile, "r");
    if(entree != NULL)
        {
        if(debutListLivraison!=NULL)
        {
          nbMaxLivraison=0;
          lastValueCodeLivraison=0;
          tmpLivraison=debutListLivraison;
          while((*tmpLivraison).suivant!=NULL)
          {
           debutListLivraison=(*debutListLivraison).suivant;
           free(tmpLivraison);
           tmpLivraison = debutListLivraison;
          }
          if((*tmpLivraison).suivant ==NULL && tmpLivraison==NULL)
          {
            free(tmpLivraison);
            debutListLivraison=NULL;  
          }
        }
        if(!feof(entree))
            {
            lastValueCodeLivraison=0;
            }
        while(!feof(entree))
            {
            livraison = tallocLivraison();
            (*livraison).suivant = NULL;
            int numero_lvr;
            ligne = fscanf(entree,"%d %d %d %s %d\n", &(*livraison).numero_lvr ,&(*livraison).code_frs_lvr, &(*livraison).code_pdt_lvr,
            (*livraison).date_lvr, &(*livraison).qte_lvr);
            if(ligne != EOF)
                {
                i++;
                if(debutListLivraison == NULL)
                    {
                    debutListLivraison = livraison;
                    tmpLivraison = debutListLivraison;
                    (*tmpLivraison).suivant = NULL;
                    lastValueCodeLivraison = (*livraison).numero_lvr;
                    livraison = NULL;
                    }
                else
                    {
                    (*tmpLivraison).suivant = livraison;
                    tmpLivraison = livraison;
                    (*tmpLivraison).suivant = NULL;
                    lastValueCodeLivraison = (*livraison).numero_lvr;
                    livraison = NULL; 
                    }
                }
            }
        }
    fclose(entree);
    nbMaxLivraison = i;
    }

    
int fournisseurExist(int numero_frs)
    {
    struct colsFournisseur *fournisseur = NULL;
    int i=0;
    int trouve=0;
    openFournisseur();
    // printf("\n%dFOUR",nbMaxFournisseur);
    if(debutListFournisseur!=NULL)
        {
        fournisseur = debutListFournisseur;
        while(i < nbMaxFournisseur)
            {
            //printf("\n\nooooH");
            if((*fournisseur).code_frs == numero_frs)
                {
                printf("Nom du Fournisseur: %s",(*fournisseur).nom_frs);
                trouve++;
                }
            fournisseur = (*fournisseur).suivant;
            i++;
        }
        }
    return trouve;
    }
    
void addCommandeAuto(int qte_auto,int code_pdt)
    {
    FILE *entree;
    int i = 1;
    struct colsCommande *commande=NULL, *commandeTmp=NULL;
    int k;
    
    commande = tallocCommande();
    
    openCommande();
    
    (*commande).numero_cde = lastValueCodeCommande + 1;
    
    printf("\n\nAjout nouvelle commande\n");
    printf("-------------------------\n");
    corriger:
    printf("\nCode fournisseur : F");
    scanf("%d", &(*commande).code_frs_cde);
    k = fournisseurExist((*commande).code_frs_cde);
    if(k==0)
        {
        printf("\n\nLe fournisseur portant le code %d est inexistant\n",(*commande).code_frs_cde);
        goto corriger;
        }
    //printf("Code produit : P");
    (*commande).code_pdt_cde=code_pdt;
    
    printf("\nDate commande : ");
    scanf("%s", (*commande).date_cde);
    //printf("Quantite commandee : ");
    (*commande).qte_cde=qte_auto;
    entree = fopen(cdeFile,"a");
    fprintf(entree,"%d %d %d %s %d\n", (*commande).numero_cde,(*commande).code_frs_cde,(*commande).code_pdt_cde,(*commande).date_cde,(*commande).qte_cde);
    
    fclose(entree);
    //printf("\n%d",nbMaxCommande);
    //getch();
    commandeTmp = debutListCommande;
    
    while(nbMaxCommande > i++)
        {                   
        commandeTmp = (*commandeTmp).suivant;
        }
    
    if(nbMaxCommande==0)
        {
        debutListCommande = commande; 
        }
    else
        {
        (*commandeTmp).suivant = commande;
        }
    nbMaxCommande++;
    lastValueCodeCommande = (*commande).numero_cde;  
    printf("Nombre de commandes lues : %d\n\n", nbMaxCommande);  
    }
    
    
    
void updateQteEnStockFacture(int qte_vendue,int code_pdt_fact)
    {
    FILE *entree;
    struct colsProduit *donnee;
    int i=0;
    int trouve=0;
    int qteCommandeAuto;
    int codepdt=0;
    int qtepdt=0;
    
    if(debutListProduit!=NULL)
        {
        donnee = debutListProduit;
        entree = fopen(pdtFile,"w+");
        while (i < nbMaxProduit)
            {
            if((*donnee).code_pdt == code_pdt_fact && qte_vendue <= (*donnee).qte_en_stock_pdt-qte_vendue)
                {
                (*donnee).qte_en_stock_pdt=(*donnee).qte_en_stock_pdt-qte_vendue;
                printf("\nProduit P%d duminue de %d articles\n\n",code_pdt_fact, qte_vendue);
                trouve++;
                }
            if((*donnee).code_pdt==code_pdt_fact && (*donnee).qte_en_stock_pdt <= (*donnee).stock_min_pdt)
                {
                trouve++;
                qteCommandeAuto=(*donnee).qte_cde_auto_pdt;
                qtepdt=(*donnee).qte_en_stock_pdt;
                }
            fprintf(entree,"%d %s %d %d %d %d\n",(*donnee).code_pdt,(*donnee).nom_pdt,(*donnee).prix_unitaire_pdt,
            (*donnee).stock_min_pdt,(*donnee).qte_en_stock_pdt,(*donnee).qte_cde_auto_pdt);
            donnee=(*donnee).suivant;
            i++;
            }
        } 
    if(trouve==0)
        {
        printf("\n\nLe produit portant le code P%d n'existe pas\n\n",code_pdt_fact);
        } 
    
    if(qtepdt!=0)
        {
        printf("\n\nLa quantite %d du produit P%d est insufisant.\n\n",qtepdt,code_pdt_fact);
        addCommandeAuto(qteCommandeAuto,code_pdt_fact);
        }
    fclose(entree);         
    }

void addLigneFacture(int qte_vendue)
    {
    struct colsLigneFacture *elem,*newelem;
    elem=NULL;
    newelem=NULL;
    newelem = tallocLigneFacture();
    (*newelem).suivant=NULL;  
    
    strcpy((*newelem).nom_pdt_fact,nomProduitFacture);    
    (*newelem).pu_fact = prixUnitaireFacture;
    (*newelem).qte_fact = qte_vendue;
    
    if(debutListLigneFacture!=NULL)
        {
        elem=debutListLigneFacture;
        while((*elem).suivant!=NULL)
            {
            elem=(*elem).suivant;
            }
        if((*elem).suivant==NULL && elem!=NULL)
            {
            (*elem).suivant=newelem;     
            }
        }
    else
        {
        debutListLigneFacture=newelem;
        (*debutListLigneFacture).suivant=NULL; 
        }
    }

void addFournisseur()
    {
    FILE *entree;
    int i = 1;
    struct colsFournisseur *fournisseur, *fournisseurTmp;
	
    fournisseur = tallocFournisseur();
    
    (*fournisseur).code_frs = lastValueCodeFournisseur + 1;
	printf("\n\nAjout nouveau fournisseur\n");
    printf("-------------------------\n");
    printf("\nNom fournisseur : ");
    scanf("%s", (*fournisseur).nom_frs);
    printf("Ville fournisseur : ");
    scanf("%s", (*fournisseur).ville_frs);
    printf("\n");
    entree = fopen(frsFile,"a");
    fprintf(entree,"%d %s %s\n",(*fournisseur).code_frs,(*fournisseur).nom_frs,(*fournisseur).ville_frs);
    fclose(entree);
    //printf("\n%d",nbMaxFournisseur);
    //getch();
    fournisseurTmp = debutListFournisseur;
    while(nbMaxFournisseur > i++)
        {                   
        fournisseurTmp = (*fournisseurTmp).suivant;
        }
    
    if(nbMaxFournisseur==0)
        {
        debutListFournisseur = fournisseur; 
        }
    else
        {
        (*fournisseurTmp).suivant = fournisseur;
        }
    nbMaxFournisseur++;
    lastValueCodeFournisseur = (*fournisseur).code_frs;  
    printf("Nombre de fournisseurs lus : %d\n\n", nbMaxFournisseur);  
    } 

void addProduit()
    {
    FILE *entree;
    int i = 1;
    struct colsProduit *produit, *produitTmp;
	
    produit = tallocProduit();
    (*produit).code_pdt = lastValueCodeProduit + 1;
	
    printf("\n\nAjout nouveau produit\n");
    printf("-------------------------\n");
    printf("\nNom produit : ");
    scanf("%s", (*produit).nom_pdt);
    printf("Prix unitaire produit : ");
    scanf("%d", &(*produit).prix_unitaire_pdt);
    printf("Stock minimum produit : ");
    scanf("%d", &(*produit).stock_min_pdt);
    printf("Quantite en stock : ");
    scanf("%d", &(*produit).qte_en_stock_pdt);
    printf("Quantite commande auto : ");
    scanf("%d", &(*produit).qte_cde_auto_pdt);
    printf("\n");
    entree = fopen(pdtFile,"a");
    fprintf(entree,"%d %s %d %d %d %d\n",(*produit).code_pdt,(*produit).nom_pdt,(*produit).prix_unitaire_pdt,
    (*produit).stock_min_pdt,(*produit).qte_en_stock_pdt,(*produit).qte_cde_auto_pdt);
    fclose(entree);
    //printf("\n%d",nbMaxProduit);
    //getch();
    produitTmp = debutListProduit;
    while(nbMaxProduit > i++)
        {                   
        produitTmp = (*produitTmp).suivant;
        }
    
    if(nbMaxProduit==0)
        {
        debutListProduit = produit; 
        }
    else
        {
        (*produitTmp).suivant = produit;
        }
    nbMaxProduit++;
    lastValueCodeProduit = (*produit).code_pdt;  
    printf("Nombre de produits lus : %d\n\n", nbMaxProduit);  
    }    

void addCommande()
    {
    FILE *entree;
    int i = 1;
    struct colsCommande *commande, *commandeTmp;
	
    commande = tallocCommande();
    (*commande).numero_cde = lastValueCodeCommande + 1;
	
    printf("\n\nAjout nouvelle commande\n");
    printf("-------------------------\n");
    
    printf("\nCode fournisseur : F");
    scanf("%d", &(*commande).code_pdt_cde);
    printf("Code produit : P");
    scanf("%d", &(*commande).code_frs_cde);
    printf("Date commande : ");
    scanf("%s", (*commande).date_cde);
    printf("Quantite commandee : ");
    scanf("%d", &(*commande).qte_cde);
    printf("\n");
    entree = fopen(cdeFile,"a");
    fprintf(entree,"%d %d %d %s %d\n", (*commande).numero_cde,(*commande).code_frs_cde,(*commande).code_pdt_cde,
                (*commande).date_cde,(*commande).qte_cde);
    fclose(entree);
    //printf("\n%d",nbMaxCommande);
    //getch();
    commandeTmp = debutListCommande;
    while(nbMaxCommande > i++)
        {                   
        commandeTmp = (*commandeTmp).suivant;
        }
    
    if(nbMaxCommande==0)
        {
        debutListCommande = commande; 
        }
    else
        {
        (*commandeTmp).suivant = commande;
        }
    nbMaxCommande++;
    lastValueCodeCommande = (*commande).numero_cde;  
    printf("Nombre de commandes lues : %d\n\n", nbMaxCommande);  
    }  

void displayDetailFacture()
    {
    struct colsLigneFacture *donnee,*p;
    donnee = debutListLigneFacture;
    int totGl=0, j = 1;
    if(debutListLigneFacture!=NULL)
        {
        printf("\n----------------------------------------------------------");
        printf("\n| No   | Produits             | P.U.   | Qte   | Total   |");
        printf("\n----------------------------------------------------------");
        while((*donnee).suivant!=NULL)
            {
            p=donnee;
            printf("\n| %-4d | %-20s | %-5d  | %-5d | %-5d   |", j++, (*donnee).nom_pdt_fact,
            (*donnee).qte_fact, (*donnee).pu_fact,(*donnee).qte_fact*(*donnee).pu_fact); 
            totGl=totGl+((*donnee).qte_fact*(*donnee).pu_fact);  
            donnee=(*donnee).suivant;
            debutListLigneFacture=donnee;
            free(p);
            }
        if((*donnee).suivant==NULL && donnee!=NULL)
            {
            p=donnee;                        
            printf("\n| %-4d | %-20s | %-5d  | %-5d | %-5d   |", j++, (*donnee).nom_pdt_fact,
            (*donnee).qte_fact, (*donnee).pu_fact,(*donnee).qte_fact*(*donnee).pu_fact);    
            totGl=totGl+((*donnee).qte_fact*(*donnee).pu_fact);
            free(p);
            debutListLigneFacture=NULL;
            //donnee=(*donnee).suivant;
            }
        }
    printf("\n----------------------------------------------------------");
    printf("\n| Grand total : %-8d                                 |", totGl);
    printf("\n----------------------------------------------------------");
    printf("\n");
    }

    
void addFacture()
    {
    FILE *entree;
    int i = 1, termine = 0 ;
    struct colsFacture *facture, *tmpFacture;
	
    facture = tallocFacture();
    (*facture).numero_fact = lastValueNumeroFacture + 1;
	
    entree = fopen(factFile,"a");
    
    printf("\n\nEtablissement facture\n");
    printf("-------------------------\n");
    
    printf("\nFacture numero : FT%d", (*facture).numero_fact);
    printf("\nDate facture : ");
    scanf("%s", (*facture).date_fact);
    
    // Recuperation ligne de commande
    while (!termine)
        {
        error:
        printf("Code produit (code = P0 pour terminer) : P");
        scanf("%d", &(*facture).code_pdt_fact);
        termine = ((*facture).code_pdt_fact == 0) ;
        
        if (!termine)
            {
            if(searchProduitFacture((*facture).code_pdt_fact))
                {
                printf("Nom pdt : %s    P.U. : %d    Qte en stock : %d \n", nomProduitFacture, prixUnitaireFacture, qteEnStockProduit);
                printf("Quantite vendue : ");
                scanf("%d", &(*facture).qte_vendue_fact);
                
                updateQteEnStockFacture((*facture).qte_vendue_fact, (*facture).code_pdt_fact); 
                
                addLigneFacture((*facture).qte_vendue_fact);
                            
                fprintf(entree,"%d %s %d %d\n", (*facture).numero_fact,(*facture).date_fact,(*facture).code_pdt_fact, (*facture).qte_vendue_fact);
                
            
                tmpFacture = debutListFacture;
                
                while(nbMaxFacture > i++)
                    {                   
                    tmpFacture = (*tmpFacture).suivant;
                    }
                
                if(nbMaxFacture==0)
                    {
                    debutListFacture = facture; 
                    }
                else
                    {
                    (*tmpFacture).suivant = facture;
                    }
                
                nbMaxFacture++;
                lastValueNumeroFacture = (*facture).numero_fact;
                }
            else
                {
                printf("\n\nLe produit portant le code P%d n'existe pas\n\n\n",(*facture).code_pdt_fact);
                } 
            } 
        }
    // Affichage de la facture.
    printf("\n\n----------------------------------------------------------");
    printf("\n| Facture Numero : FT%-5d                               |",(*facture).numero_fact);
    printf("\n| Date facture : %-10s                              |", (*facture).date_fact);
    displayDetailFacture();
    fclose(entree);
    printf("\n");
    printf("Nombre de ligne de factures lues : %d", nbMaxFacture);  
    }  

void addLivraison()
    {
    FILE *entree;
    int i = 1;
    int k;
    struct colsLivraison *livraison, *livraisonTmp;
	
    livraison = tallocLivraison();
    (*livraison).numero_lvr = lastValueCodeLivraison + 1;
	
    printf("\n\nAjout nouvelle livraison\n");
    printf("-------------------------\n");
    corrigerLV:
    printf("\nCode fournisseur : F");
    scanf("%d", &(*livraison).code_frs_lvr);
    k = fournisseurExist((*livraison).code_frs_lvr);
    if(k==0)
        {
        printf("\n\nLe fournisseur portant le code %d est inexistant\n",(*livraison).code_frs_lvr);
        goto corrigerLV;
        }
    printf("\nCode produit : P");
    scanf("%d", &(*livraison).code_pdt_lvr);
    printf("Date livraison : ");
    scanf("%s", (*livraison).date_lvr);
    printf("Quantite livree : ");
    scanf("%d", &(*livraison).qte_lvr);
    printf("\n");
    
    entree = fopen(lvrFile,"a");
    fprintf(entree,"%d %d %d %s %d\n", (*livraison).numero_lvr,(*livraison).code_frs_lvr,(*livraison).code_pdt_lvr,
    (*livraison).date_lvr,(*livraison).qte_lvr);
    updateQteEnStockLivraison((*livraison).qte_lvr,(*livraison).code_pdt_lvr);
    fclose(entree);
    
    livraisonTmp = debutListLivraison;
    while(nbMaxLivraison > i++)
        {                   
        livraisonTmp = (*livraisonTmp).suivant;
        }
    
    if(nbMaxLivraison==0)
        {
        debutListLivraison = livraison; 
        }
    else
        {
        (*livraisonTmp).suivant = livraison;
        }
    nbMaxLivraison++;
    lastValueCodeLivraison = (*livraison).numero_lvr;  
    printf("Nombre de livraisons lues : %d\n\n", nbMaxLivraison);  
    }  
 

void deleteFournisseur()
    {
    int codeRecherche, trouve = 0, i = 0;
    FILE *entree;
    struct colsFournisseur *fournisseur, *tmpFournisseur;
    
    printf("\n\nSuppresion fournisseur\n");
    printf("----------------------\n");
    printf("\nEntrez le code du fournisseur concerne : F");
    scanf("%d", &codeRecherche);
    
    if(debutListFournisseur != NULL)
        {
        entree = fopen(frsFile,"w+");
        fournisseur = debutListFournisseur;
        while(nbMaxFournisseur > i)
            {
            if(codeRecherche != (*fournisseur).code_frs)
                {
                fprintf(entree, "%d %s %s\n", (*fournisseur).code_frs, (*fournisseur).nom_frs, (*fournisseur).ville_frs);
                }
            else
                {
                printf("\nF%d %s %s (Supprime)\n", (*fournisseur).code_frs, (*fournisseur).nom_frs, (*fournisseur).ville_frs);
                trouve++;   
                }
            tmpFournisseur = fournisseur;
            
            if(fournisseur == debutListFournisseur)
                {
                debutListFournisseur = NULL;
                }
            
            fournisseur = (*fournisseur).suivant;
            i++;
            free(tmpFournisseur);
            }
        fclose(entree);
        openFournisseur();
        
        }
    if(!trouve)
        {
        printf("\nLe fournisseur portant le code F%d n'existe pas\n\n", codeRecherche);
        }
    else
        {
        printf("\nNombre de fournisseurs lus : %d\n\n", nbMaxFournisseur); 
        }
    }
    
void deleteProduit()
    {
    int codeRecherche, trouve = 0, i = 0;
    FILE *entree;
    struct colsProduit *produit, *tmpProduit;
    
    printf("\n\nSuppresion produit\n");
    printf("----------------------\n");
    printf("\nEntrez le code du produit concerne : P");
    scanf("%d", &codeRecherche);
    
    if(debutListProduit != NULL)
        {
        entree = fopen(pdtFile,"w+");
        produit = debutListProduit;
        while(nbMaxProduit > i)
            {
            if(codeRecherche != (*produit).code_pdt)
                {
                fprintf(entree, "%d %s %d %d %d %d\n", (*produit).code_pdt,(*produit).nom_pdt,(*produit).prix_unitaire_pdt,
                (*produit).stock_min_pdt,(*produit).qte_en_stock_pdt,(*produit).qte_cde_auto_pdt);
                }
            else
                {
                printf("\n%d %s %d %d %d %d (Supprime)\n", (*produit).code_pdt,(*produit).nom_pdt,(*produit).prix_unitaire_pdt,
                (*produit).stock_min_pdt,(*produit).qte_en_stock_pdt,(*produit).qte_cde_auto_pdt);
                trouve++;   
                }
            tmpProduit = produit;
            
            if(produit == debutListProduit)
                {
                debutListProduit = NULL;
                }
            
            produit = (*produit).suivant;
            i++;
            free(tmpProduit);
            }
        fclose(entree);
        openProduit();
        
        }
    if(!trouve)
        {
        printf("\nLe produit portant le code P%d n'existe pas\n\n", codeRecherche);
        }
    else
        {
        printf("\nNombre de produits lus : %d\n\n", nbMaxProduit); 
        }
    }
    
void deleteCommande()
    {
    int codeRecherche, trouve = 0, i = 0;
    FILE *entree;
    struct colsCommande *commande, *tmpCommande;
    
    printf("\n\nSuppresion commande\n");
    printf("----------------------\n");
    printf("\nEntrez le numero de la commande concerne : C");
    scanf("%d", &codeRecherche);
    
    if(debutListCommande != NULL)
        {
        entree = fopen(cdeFile,"w+");
        commande = debutListCommande;
        while(nbMaxCommande > i)
            {
            if(codeRecherche != (*commande).numero_cde)
                {
                fprintf(entree, "%d %d %d %s %d\n", (*commande).numero_cde,(*commande).code_frs_cde,(*commande).code_pdt_cde,
                (*commande).date_cde,(*commande).qte_cde);
                }
            else
                {
                printf("\nC%d F%d P%d %s %d (Supprime)\n", (*commande).numero_cde,(*commande).code_frs_cde,(*commande).code_pdt_cde,
                (*commande).date_cde,(*commande).qte_cde);
                trouve++;   
                }
            tmpCommande = commande;
            
            if(commande == debutListCommande)
                {
                debutListCommande = NULL;
                }
            
            commande = (*commande).suivant;
            i++;
            free(tmpCommande);
            }
        fclose(entree);
        openCommande();
        }
    if(trouve == 0)
        {
        printf("\nLa commande portant le numero C%d n'existe pas\n\n", codeRecherche);
        }
    else
        {
        printf("\nNombre de commandes lues : %d\n\n", nbMaxCommande); 
        }
    }

void deleteLivraison()
    {
    int codeRecherche, trouve = 0, i = 0;
    FILE *entree;
    struct colsLivraison *livraison, *tmpLivraison;
    
    printf("\n\nSuppresion livraison\n");
    printf("----------------------\n");
    printf("\nEntrez le numero de la livraison concerne : L");
    scanf("%d", &codeRecherche);
    
    if(debutListLivraison != NULL)
        {
        entree = fopen(lvrFile,"w+");
        livraison = debutListLivraison;
        while(nbMaxLivraison > i)
            {
            if(codeRecherche != (*livraison).numero_lvr)
                {
                fprintf(entree, "%d %d %d %s %d\n", (*livraison).numero_lvr,(*livraison).code_frs_lvr,(*livraison).code_pdt_lvr,
                (*livraison).date_lvr,(*livraison).qte_lvr);
                }
            else
                {
                printf("\nL%d F%d P%d %s %d (Supprime)\n", (*livraison).numero_lvr,(*livraison).code_frs_lvr,(*livraison).code_pdt_lvr,
                (*livraison).date_lvr,(*livraison).qte_lvr);
                trouve++;   
                }
            tmpLivraison = livraison;
            
            if(livraison == debutListLivraison)
                {
                debutListLivraison = NULL;
                }
            
            livraison = (*livraison).suivant;
            i++;
            free(tmpLivraison);
            }
        fclose(entree);
        openLivraison();
        }
    if(trouve == 0)
        {
        printf("\nLe livraison portant le numero L%d n'existe pas\n\n", codeRecherche);
        }
    else
        {
        printf("\nNombre de livraisons lues : %d\n\n", nbMaxLivraison); 
        }
    }

void updateFournisseur()
    {
    int codeRecherche;
    FILE *entree;
    int trouve = 0, i=0;
    struct colsFournisseur *fournisseur = NULL, *tmpFournisseur = NULL;
    
    printf("\n\nModification fournisseur\n");
    printf("------------------------\n");
    printf("\nEntrez le code du fournisseur concerne : F");
    scanf("%d", &codeRecherche);
    
    if(debutListFournisseur != NULL)
        {
        entree = fopen(frsFile, "w+");
        fournisseur = debutListFournisseur;
        while(nbMaxFournisseur > i)
            {
            if(codeRecherche == (*fournisseur).code_frs)
                {
                printf("\nF%d %s %s\n\n", (*fournisseur).code_frs, (*fournisseur).nom_frs, (*fournisseur).ville_frs);
                printf("Nom fournisseur : ");
                scanf("%s", (*fournisseur).nom_frs);
                printf("Ville du fournisseur : ");
                scanf("%s", (*fournisseur).ville_frs);
                printf("\n");
                trouve++;
                }
            fprintf(entree, "%d %s %s\n", (*fournisseur).code_frs, (*fournisseur).nom_frs, (*fournisseur).ville_frs);
            tmpFournisseur = fournisseur;
            
            if(fournisseur == debutListFournisseur)
                {
                debutListFournisseur = NULL;
                }
            
            fournisseur = (*fournisseur).suivant;
            i++;
            free(tmpFournisseur);
            }
        fclose(entree);
        openFournisseur();
        }
    if(trouve == 0)
        {
        printf("\nLe fournisseur portant le code F%d n'existe pas\n\n",codeRecherche);
        }
    else
        {
        printf("Nombre de fournisseurs lus : %d\n\n", nbMaxFournisseur); 
        }
    }

void updateProduit()
    {
    int codeRecherche;
    FILE *entree;
    int trouve = 0, i=0;
    struct colsProduit *produit = NULL, *tmpProduit = NULL;
    
    printf("\n\nModification produit\n");
    printf("------------------------\n");
    printf("\nEntrez le code du produit concerne : P");
    scanf("%d", &codeRecherche);
    
    if(debutListProduit != NULL)
        {
        entree = fopen(pdtFile, "w+");
        produit = debutListProduit;
        while(nbMaxProduit > i)
            {
            if(codeRecherche == (*produit).code_pdt)
                {
                printf("\n%d %s %d %d %d %d\n\n", (*produit).code_pdt,(*produit).nom_pdt,(*produit).prix_unitaire_pdt,
                    (*produit).stock_min_pdt,(*produit).qte_en_stock_pdt,(*produit).qte_cde_auto_pdt);
                printf("Nom produit : ");
                scanf("%s", (*produit).nom_pdt);
                printf("Prix unitaire produit : ");
                scanf("%d", &(*produit).prix_unitaire_pdt);
                printf("Stock minimum produit : ");
                scanf("%d", &(*produit).stock_min_pdt);
                printf("Quantite en stock : ");
                scanf("%d", &(*produit).qte_en_stock_pdt);
                printf("Quantite commande auto : ");
                scanf("%d", &(*produit).qte_cde_auto_pdt);
                printf("\n");
                trouve++;
                }
            fprintf(entree, "%d %s %d %d %d %d\n", (*produit).code_pdt,(*produit).nom_pdt,(*produit).prix_unitaire_pdt,
            (*produit).stock_min_pdt,(*produit).qte_en_stock_pdt,(*produit).qte_cde_auto_pdt);
            tmpProduit = produit;
            
            if(produit == debutListProduit)
                {
                debutListProduit = NULL;
                }
            
            produit = (*produit).suivant;
            i++;
            free(tmpProduit);
            }
        fclose(entree);
        openProduit();
        }
    if(trouve == 0)
        {
        printf("\nLe produit portant le code P%d n'existe pas\n\n",codeRecherche);
        }
    else
        {
        printf("Nombre de produits lus : %d\n\n", nbMaxProduit); 
        }        
    }
    
void updateCommande()
    {
    int codeRecherche;
    FILE *entree;
    int trouve = 0, i=0;
    struct colsCommande *commande = NULL, *tmpCommande = NULL;
    
    printf("\n\nModification commande\n");
    printf("------------------------\n");
    printf("\nEntrez le numero de la commande concerne : C");
    scanf("%d", &codeRecherche);
    
    if(debutListCommande != NULL)
        {
        entree = fopen(cdeFile, "w+");
        commande = debutListCommande;
        while(nbMaxCommande > i)
            {
            if(codeRecherche == (*commande).numero_cde)
                {
                printf("\nC%d F%d P%d %s %d\n\n", (*commande).numero_cde,(*commande).code_frs_cde,(*commande).code_pdt_cde,
                (*commande).date_cde,(*commande).qte_cde);
                
                printf("\nCode fournisseur : F");
                scanf("%d", &(*commande).code_pdt_cde);
                printf("Code produit : P");
                scanf("%d", &(*commande).code_frs_cde);
                printf("Date commande : ");
                scanf("%s", (*commande).date_cde);
                printf("Quantite commandee : ");
                scanf("%d", &(*commande).qte_cde);
                printf("\n");
                trouve++;
                }
            fprintf(entree, "%d %d %d %s %d\n", (*commande).numero_cde,(*commande).code_frs_cde,(*commande).code_pdt_cde,
            (*commande).date_cde,(*commande).qte_cde);
            tmpCommande = commande;
            
            if(commande == debutListCommande)
                {
                debutListCommande = NULL;
                }
            
            commande = (*commande).suivant;
            i++;
            free(tmpCommande);
            }
               
        fclose(entree);
        openCommande();
        }
    if(trouve == 0)
        {
        printf("\nLa commande portant le numero C%d n'existe pas\n\n",codeRecherche);
        }
    else
        {
        printf("Nombre de commandes lues : %d\n\n", nbMaxCommande); 
        } 
    }

void updateLivraison()
    {
    int codeRecherche;
    FILE *entree;
    int trouve = 0, i=0;
    struct colsLivraison *livraison = NULL, *tmpLivraison = NULL;
    
    printf("\n\nModification livraison\n");
    printf("------------------------\n");
    printf("\nEntrez le numero de la livraison concerne : L");
    scanf("%d", &codeRecherche);
    
    if(debutListLivraison != NULL)
        {
        entree = fopen(lvrFile, "w+");
        livraison = debutListLivraison;
        while(nbMaxLivraison > i)
            {
            if(codeRecherche == (*livraison).numero_lvr)
                {
                printf("\nL%d F%d P%d %s %d\n\n", (*livraison).numero_lvr,(*livraison).code_frs_lvr,(*livraison).code_pdt_lvr,
                (*livraison).date_lvr,(*livraison).qte_lvr);
                
                printf("\nCode fournisseur : F");
                scanf("%d", &(*livraison).code_pdt_lvr);
                printf("Code produit : P");
                scanf("%d", &(*livraison).code_frs_lvr);
                printf("Date livraison : ");
                scanf("%s", (*livraison).date_lvr);
                printf("Quantite livree : ");
                scanf("%d", &(*livraison).qte_lvr);
                printf("\n");
                trouve++;
                }
            fprintf(entree, "%d %d %d %s %d\n", (*livraison).numero_lvr,(*livraison).code_frs_lvr,(*livraison).code_pdt_lvr,
            (*livraison).date_lvr,(*livraison).qte_lvr);
            tmpLivraison = livraison;
            
            if(livraison == debutListLivraison)
                {
                debutListLivraison = NULL;
                }
            
            livraison = (*livraison).suivant;
            i++;
            free(tmpLivraison);
            }
               
        fclose(entree);
        openLivraison();
        }
    if(trouve == 0)
        {
        printf("\nLe livraison portant le numero L%d n'existe pas\n\n",codeRecherche);
        }
    else
        {
        printf("Nombre de livraisons lues : %d\n\n", nbMaxLivraison); 
        } 
    }

void updateQteEnStockLivraison(int qte_lvr,int code_pdt_lvr)
    {
    FILE *entree;
    struct colsProduit *donnee = NULL;
    int i=0;
    
    if(debutListProduit != NULL)
        {
        donnee = debutListProduit;
        entree = fopen(pdtFile, "w+");
        while (i < nbMaxProduit)
            {
            if((*donnee).code_pdt == code_pdt_lvr)
                {
                (*donnee).qte_en_stock_pdt = (*donnee).qte_en_stock_pdt + qte_lvr;
                printf("Produit P%d augmente de %d articles\n\n",(*donnee).code_pdt, qte_lvr);
                }
            fprintf(entree,"%d %s %d %d %d %d\n",(*donnee).code_pdt,(*donnee).nom_pdt,(*donnee).prix_unitaire_pdt,
            (*donnee).stock_min_pdt,(*donnee).qte_en_stock_pdt,(*donnee).qte_cde_auto_pdt);
            donnee=(*donnee).suivant;
            i++;
            }
        }
    fclose(entree); 
    }
    

void searchFournisseur()
    {
    int codeRecherche, trouve = 0, i = 0;
    struct colsFournisseur *fournisseur = NULL;
    
    if(debutListFournisseur != NULL)
        {
        printf("\n\nRechercher fournisseur\n");
        printf("----------------------\n\n");
        printf("Entrez le code du fournisseur concerne : F");
        scanf("%d", &codeRecherche);
        fournisseur = debutListFournisseur;
        while(i < nbMaxFournisseur)
            {
            if((*fournisseur).code_frs == codeRecherche)
                {
                trouve++;
                printf("\nCode fournisseur : F%d",(*fournisseur).code_frs);
                printf("\nNom fournisseur : %s",(*fournisseur).nom_frs);
                printf("\nVile fournisseur : %s",(*fournisseur).ville_frs);
                printf("\n\n");
                }
            fournisseur = (*fournisseur).suivant; 
            i++;
            }
        if(trouve == 0)
            {
            printf("\n\nLe fournisseur portant le code F%d n'existe pas\n\n\n",codeRecherche);
            }
        }
    else
        {
        printf("Informations sur les fournisseurs inexistantes\n\n");
        }
    }
    
void searchProduit()
    {
    int codeRecherche, trouve = 0, i = 0;
    struct colsProduit *produit = NULL;
    
    if(debutListProduit != NULL)
        {
        printf("\n\nRechercher produit\n");
        printf("----------------------\n\n");
        printf("Entrez le code du produit concerne : P");
        scanf("%d", &codeRecherche);
        produit = debutListProduit;
        while(i < nbMaxProduit)
            {
            if((*produit).code_pdt == codeRecherche)
                {
                trouve++;
                printf("\nCode produit : %d\n",(*produit).code_pdt);
                printf("\nNom produit : %s\n",(*produit).nom_pdt);
                printf("Prix unitaire produit : %d\n", (*produit).prix_unitaire_pdt);
                printf("Stock minimum produit : %d\n", (*produit).stock_min_pdt);
                printf("Quantite en stock : %d\n", (*produit).qte_en_stock_pdt);
                printf("Quantite commande auto : %d\n", (*produit).qte_cde_auto_pdt);
                }
            produit = (*produit).suivant; 
            i++;
            }
        if(trouve == 0)
            {
            printf("\n\nLe produit portant le code P%d n'existe pas\n\n\n",codeRecherche);
            }
        }
    else
        {
        printf("Informations sur les produits inexistantes\n\n");
        }
    }

void searchCommande()
    {
    int codeRecherche, trouve = 0, i = 0;
    struct colsCommande *commande = NULL;
    
    if(debutListCommande != NULL)
        {
        printf("\n\nRechercher commande\n");
        printf("----------------------\n");
        printf("Entrez le numero de la commande concerne : C");
        scanf("%d", &codeRecherche);
        commande = debutListCommande;
        while(i < nbMaxCommande)
            {
            if((*commande).numero_cde == codeRecherche)
                {
                trouve++;
                printf("\nNumero commande : C%d",(*commande).numero_cde);
                printf("\nCode fournisseur : F%d",(*commande).code_pdt_cde);
                printf("\nCode produit : P%d", (*commande).code_frs_cde);
                printf("\nDate commande : %s", (*commande).date_cde);
                printf("\nQuantite commandee : %d", (*commande).qte_cde);
                printf("\n\n");
                }
            commande = (*commande).suivant; 
            i++;
            }
        if(trouve == 0)
            {
            printf("\n\nLa commande portant le numero %d n'existe pas\n\n\n",codeRecherche);
            }
        }
    else
        {
        printf("Informations sur les commandes inexistantes\n\n");
        }
    }


void deleteFacture()
    {
    int codeRecherche, trouve = 0, i = 0;
    FILE *entree;
    struct colsFacture *facture, *tmpFacture;
    
    printf("\n\nSuppresion facture\n");
    printf("----------------------\n");
    printf("\nEntrez le numero de la facture concerne : FT");
    scanf("%d", &codeRecherche);
    
    if(debutListFacture != NULL)
        {
        entree = fopen(factFile,"w+");
        facture = debutListFacture;
        while(nbMaxFacture > i)
            {
            if(codeRecherche != (*facture).numero_fact)
                {
                fprintf(entree, "%d %s %d %d\n", (*facture).numero_fact,(*facture).date_fact,(*facture).code_pdt_fact,
                (*facture).qte_vendue_fact);
                }
            else
                {
                printf("%d %s P%d %d (supprime)\n", (*facture).numero_fact,(*facture).date_fact,(*facture).code_pdt_fact,
                (*facture).qte_vendue_fact);
                trouve++;   
                }
            tmpFacture = facture;
            
            if(facture == debutListFacture)
                {
                debutListFacture = NULL;
                }
            
            facture = (*facture).suivant;
            i++;
            free(tmpFacture);
            }
        fclose(entree);
        openFacture();
        }
    if(trouve == 0)
        {
        printf("\nLa facture portant le numero FT%d n'existe pas\n\n", codeRecherche);
        }
    else
        {
        printf("\nNombre de factures lues : %d\n\n", nbMaxFacture); 
        }
    }
    
void searchFacture()
    {
    int numeroRecherche, trouve = 0, i = 0, j;
    int  qte=0, sousTotal = 0, grandTotal=0;
    struct colsFacture *facture = NULL, *tmpFacture = NULL;
    
    if(debutListFacture != NULL)
        {
        printf("\n\nRechercher facture\n");
        printf("------------------\n\n");
        printf("Entrez le numero de la facture concerne : FT");
        scanf("%d", &numeroRecherche);
        facture = debutListFacture;
        // Entete facture
        while(i < nbMaxFacture && (trouve==0))
            {
            if((*facture).numero_fact == numeroRecherche)
                {
                trouve++;
                printf("\n\n----------------------------------------------------------");
                printf("\n| Facture Numero : FT%-5d                               |",(*facture).numero_fact);
                printf("\n| Date facture : %-10s                              |", (*facture).date_fact);
                }
            facture = (*facture).suivant; 
            i++;
            }
        
        if(trouve)
            {
            tmpFacture = debutListFacture;
            i = 0; 
            j = 1;
            printf("\n----------------------------------------------------------");
            printf("\n| No   | Produits             | P.U.   | Qte   | Total   |");
            printf("\n----------------------------------------------------------");
            while(i < nbMaxFacture)
                {
                if((*tmpFacture).numero_fact == numeroRecherche)
                    {
                    if(searchProduitFacture((*tmpFacture).code_pdt_fact))
                        {
                        qte = (*tmpFacture).qte_vendue_fact;
                        sousTotal = prixUnitaireFacture * qte;
                        grandTotal = grandTotal + sousTotal;
                        printf("\n| %-4d | %-20s | %-5d  | %-5d | %-5d   |", j++, nomProduitFacture, prixUnitaireFacture, qte, sousTotal);
                        }
                    }
                tmpFacture = (*tmpFacture).suivant; 
                i++;
                }
            printf("\n----------------------------------------------------------");
            printf("\n| Grand total : %-8d                                 |", grandTotal);
            printf("\n----------------------------------------------------------");
            printf("\n");
            }
        if(trouve == 0)
            {
            printf("\n\nLa facture portant le numero FT%d n'existe pas\n\n\n",numeroRecherche);
            }
        }
    else
        {
        printf("Informations sur les factures inexistantes\n\n");
        }
    }

int searchProduitFacture(int codeRecherche)
    {
    int trouve = 0, i = 0;
    struct colsProduit *produit = NULL;
    
    if(debutListProduit != NULL)
        {
        produit = debutListProduit;
        while(i < nbMaxProduit)
            {
            if((*produit).code_pdt == codeRecherche)
                {
                trouve++;
                strcpy(nomProduitFacture,(*produit).nom_pdt);
                prixUnitaireFacture = (*produit).prix_unitaire_pdt;
                qteEnStockProduit = (*produit).qte_en_stock_pdt;
                }
            produit = (*produit).suivant; 
            i++;
            }
        }
    return trouve;
    }

void searchLivraison()
    {
    int codeRecherche, trouve = 0, i = 0;
    struct colsLivraison *livraison = NULL;
    
    if(debutListLivraison != NULL)
        {
        printf("\n\nRechercher livraison\n");
        printf("----------------------\n");
        printf("Entrez le numero de la livraison concerne : L");
        scanf("%d", &codeRecherche);
        livraison = debutListLivraison;
        while(i < nbMaxLivraison)
            {
            if((*livraison).numero_lvr == codeRecherche)
                {
                trouve++;
                printf("\nNumero livraison : L%d",(*livraison).numero_lvr);
                printf("\nCode fournisseur : F%d",(*livraison).code_pdt_lvr);
                printf("\nCode produit : P%d", (*livraison).code_frs_lvr);
                printf("\nDate livraison : %s", (*livraison).date_lvr);
                printf("\nQuantite livree : %d", (*livraison).qte_lvr);
                printf("\n\n");
                }
            livraison = (*livraison).suivant; 
            i++;
            }
        if(trouve == 0)
            {
            printf("\n\nLa livraison portant le numero %d n'existe pas\n\n\n",codeRecherche);
            }
        }
    else
        {
        printf("Informations sur les livraisons inexistantes\n\n");
        }
    }


void displayFournisseur()
    {
    int i = 0;
    struct colsFournisseur *fournisseur = NULL;
    if(debutListFournisseur!=NULL)
        {
        fournisseur = debutListFournisseur;
        printf("\n\nConsultation fournisseur\n");
        printf("------------------------\n\n");
        printf("Code   Nom                  Ville\n");
        printf("---------------------------------\n");
        while(i < nbMaxFournisseur)
            {
            printf("F%-5d %-20s %-15s\n",(*fournisseur).code_frs, (*fournisseur).nom_frs,(*fournisseur).ville_frs);
            fournisseur=(*fournisseur).suivant; 
            i++;
            }
        printf("\n");
        printf("Nombre de fournisseurs lus : %d\n\n", nbMaxFournisseur);  
        }
    else
        {
        printf("Informations sur les fournisseurs inexistantes\n\n");
        }
    }

void displayProduit()
    {
    int i = 0;
    struct colsProduit *produit = NULL;
    if(debutListProduit!=NULL)
        {
        produit = debutListProduit;
        printf("\n\nConsultation produit\n");
        printf("------------------------\n\n");
        printf("Code   Nom                  P.U.  StkMin QteStk QteCde\n");
        printf("------------------------------------------------------\n");
        while(i < nbMaxProduit)
            {
            printf("P%-5d %-20s %-5d %-6d %-6d %-6d\n",(*produit).code_pdt,(*produit).nom_pdt,(*produit).prix_unitaire_pdt,
            (*produit).stock_min_pdt,(*produit).qte_en_stock_pdt,(*produit).qte_cde_auto_pdt);
            produit=(*produit).suivant; 
            i++;
            }
        printf("\n");
        printf("Nombre de produits lus : %d\n\n", nbMaxProduit);  
        }
    else
        {
        printf("Informations sur les produits inexistantes\n\n");
        }
    }

void displayCommande()
    {
    int i = 0;
    struct colsCommande *commande = NULL;
    if(debutListCommande!=NULL)
        {
        commande = debutListCommande;
        printf("\n\nConsultation commande\n");
        printf("------------------------\n\n");
        printf("NumCde CodeFrs CodePdt DateCde    QteCde\n");
        printf("----------------------------------------\n");
        while(i < nbMaxCommande)
            {
            printf("C%-5d F%-6d P%-6d %-10s %-6d\n", (*commande).numero_cde,(*commande).code_frs_cde,(*commande).code_pdt_cde,
            (*commande).date_cde,(*commande).qte_cde);
            commande=(*commande).suivant; 
            i++;
            }
        printf("\n");
        printf("Nombre de commandes lues : %d\n\n", nbMaxCommande);  
        }
    else
        {
        printf("Informations sur les commandes inexistantes\n\n");
        }
    }
    

